"use strict"; function _optionalChain(ops) { let lastAccessLHS = undefined; let value = ops[0]; let i = 1; while (i < ops.length) { const op = ops[i]; const fn = ops[i + 1]; i += 2; if ((op === 'optionalAccess' || op === 'optionalCall') && value == null) { return undefined; } if (op === 'access' || op === 'optionalAccess') { lastAccessLHS = value; value = fn(value); } else if (op === 'call' || op === 'optionalCall') { value = fn((...args) => value.call(lastAccessLHS, ...args)); lastAccessLHS = undefined; } } return value; }require('../chunk-PUXSFUR6.cjs');
require('../chunk-DW2WZVUB.cjs');
require('../chunk-AQHSLGFK.cjs');
require('../chunk-AG2W27IB.cjs');
require('../chunk-QLIFS36C.cjs');
require('../chunk-ODBA5SKE.cjs');
require('../chunk-HBGU4IMK.cjs');
require('../chunk-UJPWHP47.cjs');
require('../chunk-SYEV547Z.cjs');
require('../chunk-5G52PYZN.cjs');
require('../chunk-F2L2RVEN.cjs');
require('../chunk-7L2G4SFK.cjs');
require('../chunk-C5DWDWUS.cjs');
require('../chunk-XTDX3HZA.cjs');



var _chunkOOAMMLXYcjs = require('../chunk-OOAMMLXY.cjs');
require('../chunk-4B2XCWGL.cjs');
require('../chunk-ORGSTQ42.cjs');
require('../chunk-5CIFX7O6.cjs');


var _chunkLXSY24WIcjs = require('../chunk-LXSY24WI.cjs');
require('../chunk-KMITBP74.cjs');
require('../chunk-7BMZYEWF.cjs');
require('../chunk-S4V3EGNS.cjs');
require('../chunk-N46W55MH.cjs');
require('../chunk-UKD65B23.cjs');
require('../chunk-Y6KPVUVD.cjs');
require('../chunk-J42M6DF3.cjs');
require('../chunk-L646RZQB.cjs');
require('../chunk-ZYPCVNSG.cjs');
require('../chunk-VFIICDKU.cjs');
require('../chunk-PDXKNB3S.cjs');
require('../chunk-XR7AMYN7.cjs');
require('../chunk-SLEHBFHV.cjs');
require('../chunk-KMMN6P2X.cjs');
require('../chunk-AGQV4BOO.cjs');
require('../chunk-LURLRIHI.cjs');
require('../chunk-67Q7IWIS.cjs');
require('../chunk-B4JXPT6I.cjs');
require('../chunk-KCBJGJ24.cjs');
require('../chunk-RPAQV2V5.cjs');
require('../chunk-SVJWXMAG.cjs');
require('../chunk-RLHQ6YHC.cjs');
require('../chunk-MPD2DJAD.cjs');
require('../chunk-ZGKV237Z.cjs');
require('../chunk-7BEQHGH5.cjs');
require('../chunk-VAG3XY63.cjs');
require('../chunk-FEYF6QXS.cjs');
require('../chunk-SFVQNT7T.cjs');
require('../chunk-N7OUNPMM.cjs');
require('../chunk-Z4FNOCPD.cjs');
require('../chunk-GWXPD6I7.cjs');


var _chunkN5KTMDVOcjs = require('../chunk-N5KTMDVO.cjs');
require('../chunk-B3U4FDQH.cjs');
require('../chunk-YELWQAMG.cjs');
require('../chunk-RHWKNEUH.cjs');
require('../chunk-DRU33ZUG.cjs');
require('../chunk-LHP7OTMV.cjs');
require('../chunk-5BF2LEAU.cjs');
require('../chunk-6T6PI6XG.cjs');
require('../chunk-TUWUD5A6.cjs');
require('../chunk-CUGOCLWN.cjs');
require('../chunk-W3WUDQIC.cjs');
require('../chunk-BXM45HLQ.cjs');
require('../chunk-HHZVPIBD.cjs');
require('../chunk-YY4AHBBL.cjs');



var _chunkIMCDDJAJcjs = require('../chunk-IMCDDJAJ.cjs');

// src/common/dispose-defer.spec.ts
var log = _chunkLXSY24WIcjs.DefaultLogger.call(void 0, "dispose-test");
describe("dispose", () => {
  it("should dispose correctly", async () => {
    const disposeCalls = [];
    const dispose = _chunkOOAMMLXYcjs.useDispose.call(void 0, "a");
    const y = dispose.track({
      dispose() {
        disposeCalls.push(1);
      }
    });
    dispose.track(() => {
      disposeCalls.push(2);
    });
    const x = {
      async dispose() {
        disposeCalls.push(3);
      }
    };
    dispose.track(x);
    dispose.track();
    dispose.track(async () => {
      disposeCalls.push(4);
    });
    expect(disposeCalls).toEqual([]);
    expect(dispose.getSize()).toEqual(4);
    await dispose.untrack(x);
    expect(disposeCalls).toEqual([3]);
    expect(dispose.getSize()).toEqual(3);
    await dispose.untrack(x);
    expect(disposeCalls).toEqual([3]);
    expect(dispose.getSize()).toEqual(3);
    _optionalChain([y, 'optionalCall', _2 => _2()]);
    _optionalChain([y, 'optionalCall', _3 => _3()]);
    await dispose.untrack(x);
    expect(disposeCalls).toEqual([3, 1]);
    expect(dispose.getSize()).toEqual(2);
    await dispose.dispose();
    expect(disposeCalls).toEqual([3, 1, 4, 2]);
    expect(dispose.getSize()).toEqual(0);
    await dispose();
    expect(disposeCalls).toEqual([3, 1, 4, 2]);
    expect(dispose.getSize()).toEqual(0);
  });
  it("should be a fancy dispose itself", () => {
    let x = 1;
    class Some {
      constructor() {
        this.dispose = _chunkOOAMMLXYcjs.useDispose.call(void 0, log);
        this.dispose.track(() => {
          x = 2;
        });
      }
    }
    const obj = new Some();
    expect(x).toBe(1);
    void obj.dispose();
    expect(x).toBe(2);
  });
  it("should defer lifo", async () => {
    const stack = [];
    const defer = _chunkOOAMMLXYcjs.useDefer.call(void 0, { mode: "lifo" });
    defer.add(() => stack.push("a"));
    defer.add(() => stack.push("b"));
    defer.add(() => stack.push("c"));
    expect(stack).toEqual([]);
    void defer(true);
    expect(stack).toEqual(["c", "b", "a"]);
  });
  it("should defer fifo", async () => {
    const stack = [];
    const defer = _chunkOOAMMLXYcjs.useDefer.call(void 0, { mode: "fifo" });
    defer.add(() => stack.push("a"));
    defer.add(async () => stack.push("b"));
    defer.add(() => stack.push("c"));
    expect(stack).toEqual([]);
    await defer();
    expect(stack).toEqual(["a", "b", "c"]);
  });
  it("should dispose sync", async () => {
    const stack = [];
    const dispose = _chunkOOAMMLXYcjs.useDispose.call(void 0, );
    dispose.add(() => stack.push("a"));
    dispose.add(() => stack.push("b"));
    dispose.add(() => stack.push("c"));
    expect(stack).toEqual([]);
    await dispose(true);
    expect(stack).toEqual(["c", "b", "a"]);
  });
  it("should dispose sync using using", async () => {
    const stack = [];
    function helper() {
      var _stack = [];
      try {
        const dispose = _chunkIMCDDJAJcjs.__using.call(void 0, _stack, _chunkOOAMMLXYcjs.useDispose.call(void 0, ));
        dispose.add(() => stack.push("a"));
        dispose.add(() => stack.push("b"));
        dispose.add(() => stack.push("c"));
        expect(stack).toEqual([]);
      } catch (_) {
        var _error = _, _hasError = true;
      } finally {
        _chunkIMCDDJAJcjs.__callDispose.call(void 0, _stack, _error, _hasError);
      }
    }
    helper();
    expect(stack).toEqual(["c", "b", "a"]);
  });
  it("should dispose sync 2", async () => {
    const stack = [];
    const dispose = _chunkOOAMMLXYcjs.useDispose.call(void 0, );
    dispose.add(() => stack.push("a"));
    dispose.add(() => stack.push("b"));
    dispose.add(async () => {
      await _chunkN5KTMDVOcjs.sleep.call(void 0, 1);
      stack.push("c");
    });
    expect(stack).toEqual([]);
    expect(dispose.sync).toThrowError();
  });
  it("should use using", async () => {
    const history = [];
    function log2(s) {
      history.push(s);
    }
    class TempFile {
      constructor(path) {
        log2("constructor");
      }
      [Symbol.dispose]() {
        log2("dispose");
      }
    }
    function fn() {
      var _stack = [];
      try {
        const f = _chunkIMCDDJAJcjs.__using.call(void 0, _stack, new TempFile("abc"));
        log2("fn return");
      } catch (_) {
        var _error = _, _hasError = true;
      } finally {
        _chunkIMCDDJAJcjs.__callDispose.call(void 0, _stack, _error, _hasError);
      }
    }
    log2("fn before");
    fn();
    log2("fn after");
    expect(history).toMatchInlineSnapshot(`
      Array [
        "fn before",
        "constructor",
        "fn return",
        "dispose",
        "fn after",
      ]
    `);
  });
});
//# sourceMappingURL=dispose-defer.spec.cjs.map