"use strict";Object.defineProperty(exports, "__esModule", {value: true}); function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; } function _optionalChain(ops) { let lastAccessLHS = undefined; let value = ops[0]; let i = 1; while (i < ops.length) { const op = ops[i]; const fn = ops[i + 1]; i += 2; if ((op === 'optionalAccess' || op === 'optionalCall') && value == null) { return undefined; } if (op === 'access' || op === 'optionalAccess') { lastAccessLHS = value; value = fn(value); } else if (op === 'call' || op === 'optionalCall') { value = fn((...args) => value.call(lastAccessLHS, ...args)); lastAccessLHS = undefined; } } return value; }



var _chunk3EBWD7SYcjs = require('./chunk-3EBWD7SY.cjs');



var _chunkY6KPVUVDcjs = require('./chunk-Y6KPVUVD.cjs');




var _chunkJ42M6DF3cjs = require('./chunk-J42M6DF3.cjs');



var _chunkL646RZQBcjs = require('./chunk-L646RZQB.cjs');



var _chunkDRU33ZUGcjs = require('./chunk-DRU33ZUG.cjs');

// src/node/log/log-node.ts
var _tty = require('tty'); var _tty2 = _interopRequireDefault(_tty);
var _process = require('process'); var _process2 = _interopRequireDefault(_process);
function shouldUseColor() {
  try {
    return _chunkDRU33ZUGcjs.valueToBoolean.call(void 0, _process2.default.env.ZEED_COLOR, _tty2.default.isatty(_process2.default.stdout.fd));
  } catch (err) {
  }
  return false;
}
var defaultUseColor;
var colors = [6, 2, 3, 4, 5, 1];
function nodeSelectColorByName(namespace) {
  let hash = 0;
  for (let i = 0; i < namespace.length; i++) {
    hash = (hash << 5) - hash + namespace.charCodeAt(i);
    hash |= 0;
  }
  return colors[Math.abs(hash) % colors.length];
}
var namespaces = {};
var startTime;
function log(...args) {
  _process2.default.stdout.write(`${_chunkDRU33ZUGcjs.renderMessages.call(void 0, args)}
`);
}
var TTY_STYLE = {
  BOLD: "\x1B[1m",
  UNBOLD: "\x1B[2m",
  RED: "\x1B[31m",
  GREEN: "\x1B[32m",
  BLUE: "\x1B[34m",
  PURPLE: "\x1B[35m",
  GRAY: "\x1B[37m",
  ORANGE: "\x1B[38;5;208m",
  UNCOLOR: "\x1B[0m"
};
var colorEnd = "\x1B[0m";
function colorString(text, colorCode) {
  const colorStart = colorCode === 8 /* ORANGE */ ? TTY_STYLE.ORANGE : `\x1B[3${colorCode < 8 ? colorCode : `8;5;${colorCode}`}m`;
  return `${colorStart}${text}${colorEnd}`;
}
function colorStringList(list, style, bold = true) {
  return list.map((value) => {
    if (typeof value !== "string")
      return value;
    let start = style;
    let end = colorEnd;
    if (bold) {
      start = `${TTY_STYLE.BOLD}${start}`;
      end = `${end}${TTY_STYLE.BOLD}`;
    }
    return `${start}${value}${end}`;
  });
}
function shouldUseStack() {
  try {
    return _chunkDRU33ZUGcjs.valueToBoolean.call(void 0, _process2.default.env.ZEED_STACK, false);
  } catch (err) {
  }
  return false;
}
var defaultUseStack;
var loggerStackTraceDebug = "loggerStackTraceDebug-7d38e5a9214b58d29734374cdb9521fd964d7485";
function LoggerNodeHandler(opt = {}) {
  if (defaultUseColor == null)
    defaultUseColor = shouldUseColor();
  if (defaultUseStack == null)
    defaultUseStack = shouldUseStack();
  if (startTime == null)
    startTime = _chunkL646RZQBcjs.getTimestamp.call(void 0, );
  const {
    level = void 0,
    filter = void 0,
    colors: colors2 = defaultUseColor,
    levelHelper = true,
    nameBrackets = true,
    padding = 0,
    fill = 0,
    stack = defaultUseStack,
    time = true
  } = opt;
  const matchesNamespace = _chunkY6KPVUVDcjs.useNamespaceFilter.call(void 0, filter);
  const matchesLevel = _chunkY6KPVUVDcjs.useLevelFilter.call(void 0, level);
  return (msg) => {
    if (!matchesLevel(msg.level))
      return;
    if (!matchesNamespace(msg.name))
      return;
    const timeNow = _chunkL646RZQBcjs.getTimestamp.call(void 0, );
    const name = msg.name || "";
    let ninfo = namespaces[name || ""];
    if (ninfo == null) {
      ninfo = {
        color: nodeSelectColorByName(name)
        // time: timeNow
      };
      namespaces[name] = ninfo;
    }
    const timeDiffString = _chunkL646RZQBcjs.formatMilliseconds.call(void 0, timeNow - startTime);
    let args;
    let displayName = nameBrackets ? `[${name}]` : name;
    if (padding > 0)
      displayName = displayName.padStart(padding, " ");
    if (fill > 0)
      displayName = displayName.padEnd(fill, " ");
    if (colors2) {
      const c = ninfo.color;
      args = [`${colorString(displayName, c)} | `];
      if (msg.level === _chunkJ42M6DF3cjs.LogLevelWarn)
        args.push(...colorStringList(msg.messages, TTY_STYLE.ORANGE));
      else if (msg.level === _chunkJ42M6DF3cjs.LogLevelError)
        args.push(...colorStringList(msg.messages, TTY_STYLE.RED));
      else
        args.push(...msg.messages);
      if (time)
        args.push(colorString(`+${timeDiffString}`, c));
    } else {
      args = [displayName, ...msg.messages];
      if (time)
        args.push(`+${timeDiffString}`);
    }
    if (_optionalChain([msg, 'access', _ => _.messages, 'optionalAccess', _2 => _2[0]]) === loggerStackTraceDebug) {
      try {
        console.log(_chunk3EBWD7SYcjs.getStack.call(void 0, ));
      } catch (err) {
      }
    }
    if (stack) {
      let line = "";
      if (typeof stack === "boolean") {
        line = _chunk3EBWD7SYcjs.getSourceLocationByPrecedingPattern.call(void 0, 
          ["at Function.", "at null.log (", "at log ("],
          true
        );
        if (!line)
          line = _chunk3EBWD7SYcjs.getSourceLocation.call(void 0, 0, true);
      } else {
        const depth = typeof stack === "number" ? stack : 3;
        line = _chunk3EBWD7SYcjs.getSourceLocation.call(void 0, depth, true);
      }
      if (line)
        args.push(colorString(`(${line})`, 7 /* GRAY */));
    }
    const sep = "|";
    const charLevel = ".";
    switch (msg.level) {
      case _chunkJ42M6DF3cjs.LogLevelInfo:
        if (levelHelper)
          args[0] = `I${sep}${charLevel}   ${args[0]}`;
        log(...args);
        break;
      case _chunkJ42M6DF3cjs.LogLevelWarn:
        if (levelHelper) {
          args[0] = (colors2 ? colorString(`W${sep}${charLevel}${charLevel}  `, 8 /* ORANGE */) : `W${sep}${charLevel}${charLevel}  `) + args[0];
        }
        log(...args);
        break;
      case _chunkJ42M6DF3cjs.LogLevelError:
        if (levelHelper) {
          args[0] = (colors2 ? colorString(`E${sep}${charLevel}${charLevel}${charLevel} `, 1 /* RED */) : `E${sep}${charLevel}${charLevel}${charLevel} `) + args[0];
        }
        log(...args);
        break;
      default:
        if (levelHelper)
          args[0] = `D${sep}    ${args[0]}`;
        log(...args);
        break;
    }
  };
}






exports.colorString = colorString; exports.colorStringList = colorStringList; exports.loggerStackTraceDebug = loggerStackTraceDebug; exports.LoggerNodeHandler = LoggerNodeHandler;
//# sourceMappingURL=chunk-LL5B45YI.cjs.map