/**
 * Selective in place update, as minimal as possible.
 * Ideal for reactive objects lie Vue's `reactive`.
 */
declare function objectAssignDeepInPlace(toObject: any, fromObject: any): any;
/**
 * Create a minimal change set. Results in a new object, with only the
 * new or changed entries. Deleted entries are marked by value `null`.
 */
declare function objectDescribeChange(fromObject: any, toObject: any): any;

export { objectAssignDeepInPlace, objectDescribeChange };
